"""
Clase que dibuja una explosion de pixels
"""

import pygame
import random
import math

class Particula(pygame.sprite.Sprite):
    
    image = None

    def __init__(self, pos, velocidad, acc, color, direccion):
        pygame.sprite.Sprite.__init__(self) #call Sprite intializer
        self.velocidad = velocidad
        self.color = color
        self.direccion = direccion

        if Particula.image is None:
            self.image = pygame.Surface((2,2))
            self.image.fill(color)
            Particula.image = self.image
        else:
            self.image = Particula.image

        self.rect = self.image.get_rect()
        self.rect.center = pos
        self.acc = acc

    def update(self):
        self.rect.centery += int(self.velocidad * math.sin(self.direccion))
        self.rect.centerx += int(self.velocidad * math.cos(self.direccion))
        self.velocidad -= self.acc
        if self.velocidad <= 0:
            self.kill()

class Explosion(pygame.sprite.Sprite):
    def __init__(self, pos, color, radio):
        pygame.sprite.Sprite.__init__(self) #call Sprite intializer
        self.pos = pos
        self.radio = radio
        self.color = color
        self.image = pygame.Surface((radio, radio))
        self.image.set_colorkey((0,0,0))
        self.rect = self.image.get_rect()
        self.rect.center = pos
        self.particulas = pygame.sprite.Group()
        for i in range(self.radio*3):
            direccion = random.random() * 2 * math.pi
            velocidad = random.random() * 3
            acc = 0.05
            self.particulas.add(Particula((self.image.get_width()/2, self.image.get_height()/2), velocidad, acc, self.color, direccion))
        
    def update(self):
        self.image.fill((0,0,0))
        self.particulas.update()
        self.particulas.draw(self.image)
        flag = False
        for p in self.particulas:
            if p.alive():
                flag = True
        if not flag:
            self.kill()

