"""
Clase que define un camino a seguir
"""

import math
import pdb

class Path():
    def __init__(self):
        self.lista = []
        self.actual = 0
        self.origen = None
        self.destino = None
        self.radio = 2

    def calcular_ruta(self, origen, destino):
        """
        Inicializa la ruta
        """
        #TODO deberia esquivar los planetas a los que no vaya
        self.origen = origen
        self.destino = destino
        #tengo que averiguar por donde cae el centro
        cx = self.destino[0] + self.origen[0] / 2
        cy = self.destino[1] + self.origen[1] / 2
        dcx = self.destino[0] - self.origen[0] / self.radio
        dcy = self.destino[1] - self.origen[1] / self.radio
        self.centro = cx - dcx, cy + dcy

    def posicion(self, t):
        """
        Calcula la posicion en la ruta con el parametro t
        """
        x1, y1 = self.origen
        x2, y2 = self.destino
        x = (1-t) * (x1 - x2) + x2
        y = (1-t) * (y1 - y2) + y2

        return x,y

    def get_angle(self):
        x1, y1 = self.origen
        x2, y2 = self.destino
        if x1 == x2 and y1 > y2:
            return 90
        elif x1 == x2 and y1 < y2:
            return 270
        elif x1 < x2 and y1 == y2:
            return 0
        elif x1 > x2 and y1 == y2:
            return 180

        dx = float(x2 - x1)
        dy = float(y2 - y1)

        if y1 > y2:
            angulo = math.degrees(math.asin((dx/dy) / math.fabs(dx/dy) * dy / math.sqrt(dy**2 + dx**2)))
        
        if y1 < y2:
            angulo = math.degrees(math.asin((dx/dy) / math.fabs(dx/dy) * -dy / math.sqrt(dy**2 + dx**2)))

        if x1 > x2:
            angulo += 180

        return angulo

    def bezier(self, t):
        x = (1 - t) * (1 - t) * self.origen[0] + 2 * t * (1 - t) * self.centro[0] + t * t * self.destino[0]
        y = (1 - t) * (1 - t) * self.origen[1] + 2 * t * (1 - t) * self.centro[1] + t * t * self.destino[1]
        return x, y
