class Player():
    """
    Clase que representa a cada jugador
    """
    def __init__(self, nombre, color):
        self.nombre = nombre
        self.color = color
        self.ataque = 30
        self.planetas = []
        self.seleccionado = [] #planeta seleccionado
        self.amigos = []

    def add_friend(self, player):
        self.amigos.append(player)

    def get_friends(self):
        return self.amigos

    def get_color(self):
        return self.color

    def set_planetas(self, lista):
        self.planetas = lista

    def buscar_planeta(self, (x,y)):
        for planeta in self.planetas:
            xp, yp = planeta.get_pos()
            if xp - planeta.get_radio() < x < xp + planeta.get_radio() and \
            yp - planeta.get_radio() < y < yp + planeta.get_radio():
                return planeta
        return None

    def seleccionar_planeta(self, pos):
        sel = [i for i in self.seleccionado]
        for i in sel:
            i.unselect()

        planeta = self.buscar_planeta(pos)
        if planeta is not None:
            if planeta.get_habitante() == self:
                encontrado = self.buscar_planeta(pos)
                if encontrado is not None:
                    self.seleccionado.append(encontrado)
                    encontrado.select()

    def seleccionar_planeta_mas(self, pos):
        planeta = self.buscar_planeta(pos)
        if planeta is not None and planeta not in self.seleccionado:
            if planeta.get_habitante() == self:
                encontrado = self.buscar_planeta(pos)
                if encontrado is not None:
                    self.seleccionado.append(encontrado)
                    encontrado.select()
        elif planeta in self.seleccionado:
            p = self.seleccionado[self.seleccionado.index(planeta)]
            p.unselect()

    def atacar_planeta(self, pos):
        if len(self.seleccionado) > 0:
            atacar = self.buscar_planeta(pos)
            if atacar is not None and atacar not in self.seleccionado:
                return atacar
        return None

    def get_selected(self):
        return self.seleccionado

    def unset_selected(self, s):
        if s is None:
            self.seleccionado = None
        else:
            try:
                self.seleccionado.remove(s)
            except:
                pass

    def get_units(self, p=None):
        n = 0
        if p is None:
            for i in self.seleccionado:
                n += int(i.get_size() * (self.ataque / 100.0))
        else:
            try:
                i = self.seleccionado.index(p)
                planeta = self.seleccionado[i]
                n = int(planeta.get_size() * (self.ataque / 100.0))
            except:
                pass
        return n

    def get_ataque(self):
        return self.ataque

    def inc_ataque(self):
        if self.ataque < 100:
            self.ataque += 1

    def dec_ataque(self):
        if self.ataque > 0:
            self.ataque -= 1

    def set_ataque(self, n):
        self.ataque = n % 101

    def get_name(self):
        return self.nombre
