# -*- coding: utf-8 -*-
"""
Lee el fichero estandar de mapa
"""

from xml.dom import minidom
import Planet
import mission
import target

class ReadXmlMission():
    def __init__(self, file):
        self.file = file
        self.mis = mission.Mission()

    def read(self):
        """
        Lee el documento xml, y devuelve un Mission
        """
        dom = minidom.parse(self.file)
        # el titulo de la mision
        for i in dom.getElementsByTagName("mission"):
            for j in i.attributes.keys():
                if j == "title":
                    self.mis.title = i.attributes[j].value
        # las etiquetas intro, ending y lost
        for i in dom.getElementsByTagName("intro"):
            self.mis.intro = i.childNodes[0].nodeValue
        for i in dom.getElementsByTagName("ending"):
            self.mis.ending = i.childNodes[0].nodeValue
        for i in dom.getElementsByTagName("lost"):
            self.mis.lost = i.childNodes[0].nodeValue

        # Los mapas de la mision
        for obj in dom.getElementsByTagName("map"):
            for attr in obj.attributes.keys():
                if attr == 'value':
                    self.mis.maps.append(obj.attributes[attr].value)

        dom.unlink()
        return self.mis
