"""
Clase que define una unidad de ataque
"""

import pygame
import utils
import Path
import math
import Explosion
import random

'''
def create_units(group, num, player, destino, allsprites):
    units = [Unit(i, player, destino, allsprites) for i in range(num)]
    if group != None:
        group.add(units)
    else:
        return units
'''
def circle(t, (x,y), r):
    r1 = r
    if t > 10:
        r1 *= (t/10)
    x1 = r1 * math.cos(t) + x
    y1 = r1 * math.sin(t) + y
    return (x1,y1)

def create_units(group, num, player, destino, allsprites, planeta_orig=None):
    u = Unit(num, player, destino, allsprites, porig=planeta_orig)
    if group != None:
        group.add(u)
    else:
        return u

class Unit(pygame.sprite.Sprite):
    def __init__(self, size, player, destino, allsprites, porig):
        self.gsize = 15
        pygame.sprite.Sprite.__init__(self) #call Sprite intializer
        self.size = size
        self.size2 = self.size+10
        self.image = pygame.Surface((self.size2+1, int(self.size2 * 0.70)+1))
        self.image.fill((0,0,0))
        self.image.set_colorkey((0,0,0))
        self.player = player
        
        x1 = int(self.size2 * 0.70)
        x2 = int(self.size2 * 0.35)
        triangulo = [(0,0), (0, x1), (self.size2, x2)]
        self.rect = pygame.draw.polygon(self.image, self.player.get_color(), triangulo, 2)
        
        self.ruta = Path.Path()
        
        if porig is None:
            porig = self.player.get_selected()

        orig = porig.get_pos()
        radio = porig.get_radio()
        orig = circle(random.randint(0,10), orig, radio)
        self.ruta.calcular_ruta(orig, destino.get_pos())
        self.destino = destino

        x, y = orig
        z, t = self.destino.get_pos()
        zx = z - x
        ty = t - y
        self.dist = math.sqrt(zx * zx + ty * ty)

        self.angle = self.ruta.get_angle()

        self.image = pygame.transform.rotate(self.image, self.angle)
        self.rect = self.image.get_rect()
        self.allsprites = allsprites
        self.t = 0

    # La velocidad depende de la distancia, esto hay que arreglarlo,
    # para que sea continua, hay que tener en cuenta la distancia para
    # poder aumentar la velocidad en distancias cortas
    def update(self):
        if self.t < 1 and self.gsize > 0:
            self.t += 0.1 / (self.gsize * self.dist/300.0 * 1.0)
            self.rect.center = self.ruta.posicion(self.t)
        else:
            if self.destino.llegada_unidades(self):
                self.allsprites.add(Explosion.Explosion(self.destino.get_pos(), (255,255,0), self.get_size()*5))

    def get_size(self):
        return self.size

    def get_player(self):
        return self.player

    def explotar(self):
        #self.allsprites.add(Explosion.Explosion(self.destino.get_pos(), (255,255,0), self.get_size()*5))
        pass

    def get_pos(self):
        return self.rect.center

    def get_color(self):
        return self.player.get_color()
