
import pygame
import utils
import copy
import os

class Button(pygame.sprite.Sprite):
    def __init__(self, text, image, (x,y)):
        pygame.sprite.Sprite.__init__(self)
        self.fun = None
        self.attrs = []
        self.font_src = os.path.join(utils.data_dir, 'font.ttf')
        path = os.path.join(utils.data_dir, image)
        self.image = pygame.image.load(path)
        self.orig_img = self.image.convert_alpha()
        self.hover_img = self.hover(self.orig_img)
        self.image = self.orig_img
        
        self.rect = self.image.get_rect()
        self.rect.left = x
        self.rect.top = y
        
        self.text = text
        
        color = (255,255,255)
        font = pygame.font.Font(self.font_src, utils.font_size_big)
        text = font.render(self.text, 1, color)
        x = self.image.get_width()/2 - text.get_width()/2
        y = self.image.get_height()/2 - text.get_height()/2
        self.orig_img.blit(text, (x,y))
        self.hover_img.blit(text, (x,y))

    def attach(self, fun, kw):
        self.fun = fun
        self.attrs = kw

    def event(self, event):
        posx, posy = pygame.mouse.get_pos()
        if self.rect.collidepoint(posx, posy):
            self.image = self.hover_img
        else:
            self.image = self.orig_img
        if event.type == pygame.MOUSEBUTTONDOWN and event.button == 1:
            if self.rect.collidepoint(posx, posy):
                self.fun(*self.attrs)


    def hover(self, img):
        def m5(x):
            if x != 0:
                x = x + 50
            if x > 255:
                x = 255
            return x

        image = copy.copy(img)
        for x in range(image.get_width()):
            for y in range(image.get_height()):
                p = image.get_at((x,y))
                p = map(m5, p)
                image.set_at((x,y), p)
        return image
