import utils
import pygame
import time
import os

class Clock(pygame.sprite.Sprite):
    def __init__(self, screen, dir='up', start=0):
        pygame.sprite.Sprite.__init__(self)
        self.screen = screen
        self.dir = dir
        self.start = start
        self.i = time.time()
        self.image = pygame.Surface((200, 100))
        self.rect = self.image.get_rect()
        self.rect.left = self.screen.get_width() - 100
        self.rect.top = 0
        self.font_src = os.path.join(utils.data_dir, 'font.ttf')

    def update(self):

        self.passed = time.time() - self.i
        min = 0
        hour = 0
        if self.dir == 'up':
            sec = int(self.passed) + self.start
        else:
            sec = self.start - int(self.passed)
        while sec > 60:
            min += 1
            sec -= 60
        while min > 60:
            hour += 1
            min -= 60

        timestr = '%02d:%02d:%02d' % (hour, min, sec)

        font = pygame.font.Font(self.font_src, utils.font_size)
        color = (250,250,250)
        txt = font.render(timestr, 1, color)

        self.image = pygame.Surface((txt.get_width(), txt.get_height()))
        self.image.fill((0,0,0))
        self.image.set_colorkey((0,0,0))
        self.rect = self.image.get_rect()
        self.rect.left = self.screen.get_width() - 100
        self.rect.top = 0

        self.image.blit(txt, (0,0))

    def restart(self):
        self.i = time.time()
        self.passed = 0

    def play(self):
        self.i = time.time()
