#Import Modules
import os
import sys
import pygame
import utils
import Planet
import Minimap
import Background
import ReadXmlMap
import info
import Player
import IA
from pygame.locals import *

if not pygame.font: print 'Warning, fonts disabled'
if not pygame.mixer: print 'Warning, sound disabled'

def Editor(screen):

    #Put Text On The Background, Centered
    font = pygame.font.Font(None, utils.font_size)
 
    #Display The Background
    pygame.display.flip()

    #Prepare Game Objects
    pclock = pygame.time.Clock()


    player1 = Player.Player(*utils.PLAYER)
    player2 = IA.IA1(*utils.IA1)
    player3 = IA.IA2(*utils.IA2)
    player4 = IA.IA3(*utils.IA3)
    player5 = IA.IA4(*utils.IA4)
    jugadores_ia = [player2, player3, player4, player5]
    lista_de_jugadores = [player1, player2, player3, player4, player5]


    print "Mapa a editar:"
    map1 = raw_input()
    if map1 == '':
        map1 = os.path.join(utils.data_dir,"maps","editor","editor.xml")
    readxml = ReadXmlMap.ReadXmlMap(map1, lista_de_jugadores) 
    map = readxml.read()

    print "ancho:"
    map.size = [1000,1000]
    #map.size[0] = int(raw_input())
    print "alto:"
    #map.size[1] = int(raw_input())
    
    targets = readxml.get_targets()
    #nfo = info.Info(screen, 'OBJETIVOS', targets[0].text)
    background = Background.Background(map, screen)
    
    lista_de_planetas = map.get_planets()

    minimap = Minimap.Minimap(map, [], screen, background)
    allsprites = pygame.sprite.OrderedUpdates(lista_de_planetas)
    othersprites = pygame.sprite.OrderedUpdates((background, minimap))

    allsprites.update()
   
    inc = False
    dec = False
    planet = None
    planet_size = 100
    player = 0
    #Main Loop
    while 1:
        pclock.tick(40)

        #Handle Input Events
        for event in pygame.event.get():
            if planet is not None:
                posx, posy = pygame.mouse.get_pos()
                planet.rect.center = posx, posy

            if event.type == QUIT:
                return
            elif event.type == KEYDOWN and event.key == K_ESCAPE:
                if planet is not None:
                    planet = None
                else:
                    return
            # Fullscreen
            elif event.type == KEYDOWN and event.key == K_f:
                pygame.display.toggle_fullscreen()
    
            # Se borra el mapa
            elif event.type == MOUSEBUTTONDOWN and event.button == 3:
                posx, posy = pygame.mouse.get_pos()
                scrollx, scrolly = background.get_scroll()
                relpos = minimap.inside((posx, posy))
                if relpos is not None:
                    background.set_pos(minimap.calc_real_pos(relpos))
                else:
                    posx -= scrollx
                    posy -= scrolly
                    planeta = buscar_planeta((posx, posy), lista_de_planetas)
                    if planeta is not None:
                        map.planets.remove(planeta)
                        planeta.kill()
            
            # Se pega en el mapa
            elif event.type == MOUSEBUTTONDOWN and event.button == 1:
                posx, posy = pygame.mouse.get_pos()
                scrollx, scrolly = background.get_scroll()
                relpos = minimap.inside((posx, posy))
                if relpos is not None:
                    background.set_pos(minimap.calc_real_pos(relpos))
                    minimap.set_drag()
                else:
                    if planet is not None:
                        planet.rect.centerx -= background.rect.left
                        planet.rect.centery -= background.rect.top
                        allsprites.add(planet)
                        map.add(planet)
                        planet = None
                    else:
                        posx -= scrollx
                        posy -= scrolly
                        planet = buscar_planeta((posx, posy), lista_de_planetas)
                        if planet is not None:
                            map.planets.remove(planet)
                            planet.kill()


            elif event.type == MOUSEBUTTONUP and event.button == 1:
                minimap.unset_drag()

            # Se sube o baja el porcentaje de ataque
            elif event.type == MOUSEBUTTONDOWN and event.button == 4:
                pass
            elif event.type == MOUSEBUTTONDOWN and event.button == 5:
                pass

            elif event.type == KEYDOWN and event.key == K_w:
                inc = True
            elif event.type == KEYUP and event.key == K_w:
                inc = False
            elif event.type == KEYDOWN and event.key == K_s:
                dec = True
            elif event.type == KEYUP and event.key == K_s:
                dec = False
            elif event.type == KEYDOWN and event.key == K_p:
                planet = add_planet(lista_de_planetas)
                planet_size = planet.size
                planet.update()

            elif event.type == KEYDOWN:
                if event.key == K_e:
                    if planet is not None:
                        player = (player + 1) % len(lista_de_jugadores)
                        planet.habitante = lista_de_jugadores[player]
                        planet.colorear(planet.habitante.get_color())
                        planet.rect.center = pygame.mouse.get_pos()
                        planet.size = planet_size
                        planet.update()

                if event.key == K_g:
                    guardar(map, background, 'fichero.xml')

        if inc:
            if planet is not None:
                planet = up_planet(planet,1)
                planet_size = planet.size
                planet.update()
        elif dec:
            if planet is not None:
                planet = up_planet(planet,-1)
                planet_size = planet.size
                planet.update()


        othersprites.update()
        #allsprites.update()

        #Draw Everything
        screen.fill((0,0,0))
        allsprites.draw(background.get_image())
        othersprites.draw(screen)

        if planet is not None:
            #planet.update()
            screen.blit(planet.image, planet.rect)

        pygame.display.flip()

def add_planet(lista_de_planetas):
    return Planet.Planet((0,0), name="planeta%d" % len(lista_de_planetas))

def up_planet(planet, n):
    pos = planet.get_pos()
    size = planet.get_size()+n
    return Planet.Planet(pos, size=size, name=planet.name)

def buscar_planeta((x,y), planetas):
    for planeta in planetas:
        xp, yp = planeta.get_pos()
        if xp - planeta.get_radio() < x < xp + planeta.get_radio() and \
        yp - planeta.get_radio() < y < yp + planeta.get_radio():
            return planeta
    return None

def guardar(map, background, nombre):
    path = os.path.join(utils.data_dir,'maps','editor', nombre)
    file = open(path, 'w')
    target = 'master of universe'
    desc = 'Conquista el Universo'

    file.write('<map width="%d" height="%d">\n' % (map.size[0], map.size[1]))
    file.write('<title>%s</title>\n' % nombre[0:-4])
    file.write('<target type="%s">%s</target>\n' % (target, desc))
    mc = background.rect.center
    for p in map.get_planets():
        x = p.rect.centerx
        y = p.rect.centery

        h = p.habitante
        if h is None:
            h = "None"
        else:
            h = p.habitante.nombre
        planet = (x, y, p.orig_size, h, p.name)
        file.write('<planet x="%d" y="%d" size="%d" habitado="%s" name="%s"/>\n' % planet)
    file.write('</map>\n')

