#Import Modules
import os
import sys
import pygame
import utils
import Planet
import Player
import Unit
import ReadXmlMap
import ReadXmlMission
import Minimap
import Background
import IA
import info
import clock
import status
import guias
import seleccion
from pygame.locals import *

if not pygame.font: print 'Warning, fonts disabled'
if not pygame.mixer: print 'Warning, sound disabled'


def game(screen, map='map1', mission=False):
    font_src = os.path.join(utils.data_dir, 'font.ttf')
    if mission:
        file = os.path.join(utils.data_dir,'maps','mision',map+'.xml')
        mission = ReadXmlMission.ReadXmlMission(file)
        mission = mission.read()
        nfo = info.Info(screen, mission.title, mission.intro)
        nfo.show(screen)
        ret = False
        for m in mission.maps:
            ret = game(screen, m)
            if not ret:
                break
        if ret:
            nfo = info.Info(screen, mission.title + ' WIN', mission.ending)
        else: 
            nfo = info.Info(screen, mission.title + ' LOST', mission.lost)
        nfo.show(screen)
        return ret
        

    #Put Text On The Background, Centered
    font = pygame.font.Font(font_src, utils.font_size)
 
    #Display The Background
    pygame.display.flip()

    #Prepare Game Objects
    pclock = pygame.time.Clock()

    #TODO automatizar, hay que crear un menu de seleccion
    player1 = Player.Player(*utils.PLAYER)
    player2 = IA.IA1(*utils.IA1)
    player3 = IA.IA2(*utils.IA2)
    player4 = IA.IA3(*utils.IA3)
    player5 = IA.IA4(*utils.IA4)
    #player6 = IA.IA5(*utils.IA5)
    #jugadores_ia = [player2, player3, player4, player5, player6]
    jugadores_ia = [player2, player3, player4, player5]
    #lista_de_jugadores = [player1, player2, player3, player4, player5, player6]
    lista_de_jugadores = [player1] + jugadores_ia

    if map != None:
        map1 = os.path.join(utils.data_dir,"maps",map+".xml")
        readxml = ReadXmlMap.ReadXmlMap(map1, lista_de_jugadores)
        map = readxml.read()
    else:
        import random
        lista_de_jugadores2 = []
        lista_de_jugadores2.append(lista_de_jugadores[0])
        lista_de_jugadores2.append(random.choice(lista_de_jugadores[1:]))

        #lista_de_jugadores2.append(player6)

        lista_de_jugadores = lista_de_jugadores2
        jugadores_ia = [lista_de_jugadores2[1]]
        map1 = os.path.join(utils.data_dir, "")
        readxml = ReadXmlMap.ReadXmlMap(map1, lista_de_jugadores)
        map = readxml.get_load_random_map()

    targets = readxml.get_targets()
    nfo = info.Info(screen, 'OBJETIVOS ' + map.title, targets[0].text)
    background = Background.Background(map, screen)
    
    lista_de_planetas = map.get_planets()
    unitsprites = pygame.sprite.Group()

    for player in lista_de_jugadores:
        player.set_planetas(lista_de_planetas)
        player.unitsprites = unitsprites

    minimap = Minimap.Minimap(map, unitsprites, screen, background)
    allsprites = pygame.sprite.OrderedUpdates(lista_de_planetas)
    othersprites = pygame.sprite.OrderedUpdates((background, minimap,\
        nfo))

    allsprites.update()
    
    inc = False
    dec = False
    c = None
    
    import music
    music.play()

    # fin de nivel
    flag = False
    nUnits_total = 0
    
    # Status
    state = status.Status(screen, lista_de_jugadores,\
            lista_de_planetas, unitsprites)
    othersprites.add(state)

    for p in lista_de_planetas:
        p.set_bg(background)

    # Lineas de planetas seleccionados al destino
    guia = guias.Guias(player1, lista_de_planetas, background)

    # Cuadro para la seleccion multiple
    sel = seleccion.SelRec(player1, lista_de_planetas)

    #Main Loop
    while 1:
        pclock.tick(40)

        if nfo is None and c is None:
            c = clock.Clock(screen, dir='up', start=0)
            othersprites.add(c)

        # Comprobamos si has conseguido el objetivo
        all_ok = True
        for t in targets:
            if not t.check(lista_de_planetas, unitsprites):
                all_ok = False
                break
        # Has perdido
        if nUnits_total == 0:
            if nfo is None and not flag:
                flag = True
                nfo = info.Info(screen, 'INFO ' + map.title, 'GAME OVER', big=True)
                othersprites.add(nfo)

        # Has ganado
        if all_ok:
            if nfo is None and not flag:
                flag = True
                nfo = info.Info(screen, 'INFO ' + map.title, 'Objetivo completado', big=True)
                othersprites.add(nfo)
        # FIN de juego
        if flag and nfo is None:
            music.stop()
            return all_ok

        #IA update
        if nfo is None:
            ia_units = []
            for player in jugadores_ia:
                ia_units.append(player.update(allsprites))
            for ia_unit in ia_units:
                if ia_unit is not None:
                    unitsprites.add(ia_unit)

        #Handle Input Events
        for event in pygame.event.get():
            if event.type == QUIT:
                music.stop()
                return all_ok
            elif event.type == KEYDOWN and event.key == K_ESCAPE:
                if nfo is not None:
                    nfo.kill()
                    nfo = None
                else:
                    music.stop()
                    return all_ok
            # Fullscreen
            elif event.type == KEYDOWN and event.key == K_f:
                pygame.display.toggle_fullscreen()
    
            # Boton derecho, seleccion
            elif event.type == MOUSEBUTTONDOWN and event.button == 3:
                posx, posy = pygame.mouse.get_pos()
                scrollx, scrolly = background.get_scroll()
                relpos = minimap.inside((posx, posy))
                if relpos is not None:
                    background.set_pos(minimap.calc_real_pos(relpos))
                else:
                    posx -= scrollx
                    posy -= scrolly
                    mods = pygame.key.get_mods()
                    if mods & KMOD_LSHIFT:
                        player1.seleccionar_planeta_mas((posx, posy))
                    else:
                        player1.seleccionar_planeta((posx, posy))

            # Boton izquierdo, ataque
            elif event.type == MOUSEBUTTONDOWN and event.button == 1:
                posx, posy = pygame.mouse.get_pos()
                scrollx, scrolly = background.get_scroll()
                relpos = minimap.inside((posx, posy))
                if relpos is not None:
                    background.set_pos(minimap.calc_real_pos(relpos))
                    minimap.set_drag()
                else:
                    posx -= scrollx
                    posy -= scrolly
                    destino = player1.atacar_planeta((posx, posy))
                    n = player1.get_units()
                    if destino is not None and n > 0:
                        planetas = player1.get_selected()
                        for i in planetas:
                            n = player1.get_units(i)
                            Unit.create_units(unitsprites, n, player1, destino, allsprites, planeta_orig=i)
                            i.salida_unidades(n)

                    elif destino is None:
                        # Pintamos el rectangulo de seleccion
                        sel.set((posx, posy), (0,0))

            elif event.type == MOUSEBUTTONUP and event.button == 1 and sel.get():
                # seleccionamos
                sel.seleccionar()

            elif event.type == MOUSEBUTTONUP and event.button == 1:
                minimap.unset_drag()

            # Se sube o baja el porcentaje de ataque
            elif event.type == MOUSEBUTTONDOWN and event.button == 4:
                player1.inc_ataque()
            elif event.type == MOUSEBUTTONDOWN and event.button == 5:
                player1.dec_ataque()

            elif event.type == KEYDOWN and event.key == K_w:
                inc = True
            elif event.type == KEYUP and event.key == K_w:
                inc = False
            elif event.type == KEYDOWN and event.key == K_s:
                dec = True
            elif event.type == KEYUP and event.key == K_s:
                dec = False

        if inc:
            player1.inc_ataque()
        elif dec:
            player1.dec_ataque()

        othersprites.update()
        if not nfo:
            allsprites.update()
            unitsprites.update()
        else:
            nfo.update()

        #Draw Everything
        screen.fill((0,0,0))
        guia.update(background.get_image())
        allsprites.draw(background.get_image())
        unitsprites.draw(background.get_image())

        # Cuadrito de seleccion
        if sel.get():
            posx, posy = pygame.mouse.get_pos()
            scrollx, scrolly = background.get_scroll()
            posx -= scrollx
            posy -= scrolly

            sel.draw((posx, posy), background.get_image())

        othersprites.draw(screen)

        # los players
        nUnits = 0
        for p in lista_de_planetas:
            if p.habitante == player1:
                nUnits += p.size
        nUnits_vuelo = 0
        for u in unitsprites:
            if u.player == player1:
                nUnits_vuelo += u.size
        nUnits_total = nUnits_vuelo + nUnits

        marcador = str(player1.get_ataque())+"% ATAQUE | "
        marcador += str(nUnits) + " Unidades | "
        marcador += str(nUnits_vuelo) + " Unidades en vuelo"
        text = font.render(marcador, 1, (255, 255, 255))
        textpos = text.get_rect()
        textpos.bottom = screen.get_height()
        screen.blit(text, textpos)

        pygame.display.flip()

    #Game Over


