import pygame

class Guias:
    '''
    Dibuja lineas desde los planetas seleccionados hacia un planeta
    sobre que el que esta el cursor
    '''
    def __init__(self, player, lista_planetas,  background):
        self.player = player
        self.lista_plaetas = lista_planetas
        self.back = background
        self.color = (200,255,200)
        w,h = background.size
        self.surf = pygame.Surface((w, h))
        self.surf = self.surf.convert()
        self.surf.set_alpha(70)
        self.surf.set_colorkey((0,0,0))

    def update(self, screen):
        '''
        Mira si el cursor esta sobre un planeta, y si hay algun
        planeta seleccionado, y en ese caso dibuja las lineas sobre
        screen.
        '''
        
        sel = self.player.get_selected()
        if len(sel) > 0:
            x, y = pygame.mouse.get_pos()
            scrollx, scrolly = self.back.get_scroll()
            x -= scrollx
            y -= scrolly

            dst = self.player.buscar_planeta((x,y))
            if dst is not None:
                dx, dy = dst.get_pos()
                dst_pos = (dx,dy)
                if dst not in sel:
                    self.surf.fill((0,0,0))
                    for p in sel:
                        px, py = p.get_pos()
                        pygame.draw.line(self.surf, self.color,\
                                (px, py), dst_pos, 6)
                        pygame.draw.circle(self.surf, self.color, \
                            (px,py), p.get_radio()+5)


                    pygame.draw.circle(self.surf, self.color, \
                            dst_pos, dst.get_radio()+5)


                    screen.blit(self.surf, (0,0))


