import pygame
import os
import utils

class Input(pygame.sprite.Sprite):
    def __init__(self, value="", size=50, pos=(0,0)):
        pygame.sprite.Sprite.__init__(self)
        self.text = value
        self.size = 50
        self.font_src = os.path.join(utils.data_dir, 'font.ttf')

        color = (255,255,255)
        self.font = pygame.font.Font(self.font_src, utils.font_size_big)
        self.text_img = self.font.render(self.text, 1, color)

        self.h = self.text_img.get_height() + 4
        self.w = self.text_img.get_width() + 100

        self.x = pos[0]
        self.y = pos[1]

        self.image = pygame.Surface((self.w, self.h))
        self.image.fill((0,0,0))
        self.image.blit(self.text_img, (0,0))
        self.rect = self.image.get_rect()
        self.rect.left = self.x
        self.rect.top = self.y
        rect = pygame.Rect(0,0, self.w, self.h)
        pygame.draw.rect(self.image, (0,100, 0), rect, 2)
        self.editable = False

    def update(self):
        # Aqui iria el editor
        # si se hace click sobre el input, se convierte en editable
        pass

