import pygame
import button
import input
import utils
import os

class Menu:
    def __init__(self, screen):
        self.screen = screen
        # nombre: [funcion on click, argumentos]
        self.opts = []
        self.buttons = None
        self.input_sprite = None
        self.inputs = {}

    def add_opt(self, nombre, funcion, *kw):
        self.opts.append([nombre, funcion, kw])

    def add_input(self, name, value):
        self.inputs[name] = value

    def get_input(self, name):
        return self.inputs[name]

    def get_inputs(self):
        return self.inputs

    def main(self):
        import music
        import random
        music.play()
        x = 100
        y = 100
        self.buttons = pygame.sprite.OrderedUpdates()
        for o,f,a in self.opts:
            f = [f,a]
            b = button.Button(o, 'button.png', (x,y))
            b.attach(*f)
            y += b.image.get_height()+20
            self.buttons.add(b)

        self.input_sprite = pygame.sprite.OrderedUpdates()
        for k,v in self.inputs.items():
            i = input.Input(v, 100, (x,y))
            y += i.image.get_height()+20
            self.input_sprite.add(i)

        # Fondo de estrellas
        w = self.screen.get_width()
        h = self.screen.get_height()
        surface = pygame.Surface((w,h))
        surface.fill((0,0,0))
        for i in range(w / 2):
            random.seed()
            centerx = random.randint(0, w)
            centery = random.randint(0, h)
            rect = pygame.Rect(centerx, centery, 2, 2)
            pygame.draw.rect(surface, (255,255,255), rect)

        bg_path = os.path.join(utils.data_dir, 'background.png')
        logo_path = os.path.join(utils.data_dir, 'logo.png')
        image = pygame.image.load(bg_path)
        image2 = pygame.image.load(logo_path)
        logo = image2.convert_alpha()
        image = image.convert_alpha()
        x = w/2 - 100
        y = -10
        surface.blit(image, (x, y))
        x = w - logo.get_width() - 20
        y = h - logo.get_height() - 20
        surface.blit(logo, (x, y))

        pclock = pygame.time.Clock()
        while True:
            music.update()
            self.screen.blit(surface, (0,0))
            pclock.tick(40)
            for event in pygame.event.get():
                for b in self.buttons:
                    b.event(event)
                if event.type == pygame.QUIT:
                    return
                elif event.type == pygame.KEYDOWN and \
                    event.key == pygame.K_ESCAPE:
                    return

            self.buttons.draw(self.screen)
            self.input_sprite.draw(self.screen)

            pygame.display.flip()
