#!/usr/bin/python
# -*- coding: utf-8 -*-
"""
pixWar
Un juego de estrategia en tiempo real

TODO
-inteligencia artificial
    *ataca a planetas mas cercanos, hasta conquistar
    *ataca siempre planetas ocupados por el player1
    *ataca con muchas unidades los planetas cercanos, y con pocas las lejanas
??poder seleccionar varios planetas, y atacar con todos a la vez
??satelites, unidad especial, premio, exploratoria: (se pierde un gran numero de unidades para crear un satelite)
    -cuando haya oscuridad, descubre mapa, se puede lanzar al vacio
    -cuando este orbitando a un planeta, aumenta su velocidad de crecimiento
    -cuando orbita un planeta enemigo, disminuye su velocidad de crecimiento
"""


#Import Modules
import pygame
import game
import net_game
import editor
import menu
import utils
import sys
import os
import re

if not pygame.font: print 'Warning, fonts disabled'
if not pygame.mixer: print 'Warning, sound disabled'

def pixwar():
    "Inicializamos todo el sistema grafico"

    #resolucion = (1024,768)
    resolucion = (800, 600)
    #Initialize Everything
    pygame.init()
    if len(sys.argv) == 2 and sys.argv[1] == '-f':
        flags = pygame.FULLSCREEN | pygame.HWSURFACE | pygame.DOUBLEBUF
    else:
        flags = pygame.DOUBLEBUF 
    screen = pygame.display.set_mode(resolucion, flags)

    pygame.display.set_caption('Pix War')

    submenu = menu.Menu(screen)
    maps = os.listdir(os.path.join(utils.data_dir, 'maps'))
    xml = re.compile('.*\.xml$')
    for m in maps:
        if not xml.match(m):
            continue
        title = m[0:-4].upper()
        map = m[0:-4]
        submenu.add_opt(title, game.game, screen, map)

    mision = menu.Menu(screen)
    misiones = os.listdir(os.path.join(utils.data_dir, 'maps','mision'))
    for m in misiones:
        if not xml.match(m):
            continue
        title = m[0:-4].upper()
        mis = m[0:-4]
        mision.add_opt(title, game.game, screen, mis, True)
        #mision.add_input('tal', 'cual')

    m = menu.Menu(screen)
    #m.add_opt('PARTIDA RAPIDA', submenu.main)
    m.add_opt('PARTIDA RAPIDA', game.game, screen, None)
    #m.add_opt('JUEGO EN RED', net_game.net_game, screen, map)
    m.add_opt('MODO MISION', mision.main)
    m.add_opt('CREDITOS', creditos, screen)
    #m.add_opt('EDITOR', editor.Editor, screen)
    m.add_opt('SALIR', sys.exit)
    m.main()
    
def creditos(screen):
    import info
    import random
    texto = '''
    Juego disenado, programado y producido por:

    Daniel Garcia Moreno dani@danigm.net para pixjuegos.

    Musica de Derek Oldman, jamendo.com

    Gracias por jugar.
    '''
    credits = info.Info(screen, 'CREDITOS', texto)

    w = screen.get_width()
    h = screen.get_height()
    surface = pygame.Surface((w,h))
    surface.fill((0,0,0))
    for i in range(w / 2):
        random.seed()
        centerx = random.randint(0, w)
        centery = random.randint(0, h)
        rect = pygame.Rect(centerx, centery, 2, 2)
        pygame.draw.rect(surface, (255,255,255), rect)

    while True:

        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return
            elif event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
                credits.kill()
 
        if credits.update():
            return
        screen.blit(surface, (0,0))
        screen.blit(credits.image, credits.rect)
        pygame.display.flip()

#this calls the 'main' function when this script is executed
if __name__ == '__main__':
    if len(sys.argv) == 2:
        utils.data_dir = sys.argv[1]
    else:
        ruta = os.path.split(sys.argv[0])[0]
        utils.data_dir = os.path.join(ruta, utils.data_dir)
    pixwar()


