
import utils
import pygame
import time
import os

class Status(pygame.sprite.Sprite):
    def __init__(self, screen, players, planetas, units):
        pygame.sprite.Sprite.__init__(self)
        self.players = players
        self.screen = screen
        self.planets = planetas
        self.units = units
        self.font_src = os.path.join(utils.data_dir, 'font.ttf')
        self.font = pygame.font.Font(self.font_src, utils.font_size_small)
        self.image, self.rect = self.calc_all()
        self.spin = 0

    def update(self):
        if self.spin == 0:
            self.image, self.rect = self.calc_all()
        self.spin = (self.spin + 1) % 15


    def calc_one(self, player):
        nUnits = 0
        for p in self.planets:
            if p.habitante == player:
                nUnits += p.size
        nUnits_vuelo = 0
        for u in self.units:
            if u.player == player:
                nUnits_vuelo += u.size
        nUnits_total = nUnits_vuelo + nUnits
        return nUnits, nUnits_vuelo 

    def calc_all(self):
        txts = []
        for i in self.players:
            color = i.get_color()
            units, units_v = self.calc_one(i)
            units_t = units + units_v
            if units_t == 0:
                self.players.remove(i)
                continue
            unidades = (units_t, units, units_v)
            estado = '%03d Unidades | %03d en Planetas | %03d en vuelo' % unidades
            txt = self.font.render(estado, 1, color)
            txts.append([units_t, txt])
        txts.sort(reverse=True)

        image = pygame.Surface((1,1))
        x = 0
        y = 0
        if len(txts) > 0:
            h1 = txts[0][1].get_height()
            h = len(txts) * h1
            w = txts[0][1].get_width()
            image = pygame.Surface((w+10, h))
            image.fill((0,0,0))
            image.set_alpha(150)
            for i, t in enumerate(txts):
                image.blit(t[1], (x,y+h1*i))
            
        rect = image.get_rect()
        rect.left = 10
        rect.top = 10
        return image, rect
